73e2e628631bbc71ea84388b37e6ae4d60917734
[arvados.git] / build / run-build-packages.sh
1 #!/bin/bash
2 # Copyright (C) The Arvados Authors. All rights reserved.
3 #
4 # SPDX-License-Identifier: AGPL-3.0
5
6 . `dirname "$(readlink -f "$0")"`/run-library.sh
7 . `dirname "$(readlink -f "$0")"`/libcloud-pin.sh
8
9 read -rd "\000" helpmessage <<EOF
10 $(basename $0): Build Arvados packages
11
12 Syntax:
13         WORKSPACE=/path/to/arvados $(basename $0) [options]
14
15 Options:
16
17 --build-bundle-packages  (default: false)
18     Build api server and workbench packages with vendor/bundle included
19 --debug
20     Output debug information (default: false)
21 --target <target>
22     Distribution to build packages for (default: debian8)
23 --only-build <package>
24     Build only a specific package (or $ONLY_BUILD from environment)
25 --command
26     Build command to execute (defaults to the run command defined in the
27     Docker image)
28
29 WORKSPACE=path         Path to the Arvados source tree to build packages from
30
31 EOF
32
33 EXITCODE=0
34 DEBUG=${ARVADOS_DEBUG:-0}
35 TARGET=debian8
36 COMMAND=
37
38 PARSEDOPTS=$(getopt --name "$0" --longoptions \
39     help,build-bundle-packages,debug,target:,only-build: \
40     -- "" "$@")
41 if [ $? -ne 0 ]; then
42     exit 1
43 fi
44
45 eval set -- "$PARSEDOPTS"
46 while [ $# -gt 0 ]; do
47     case "$1" in
48         --help)
49             echo >&2 "$helpmessage"
50             echo >&2
51             exit 1
52             ;;
53         --target)
54             TARGET="$2"; shift
55             ;;
56         --only-build)
57             ONLY_BUILD="$2"; shift
58             ;;
59         --debug)
60             DEBUG=1
61             ;;
62         --command)
63             COMMAND="$2"; shift
64             ;;
65         --)
66             if [ $# -gt 1 ]; then
67                 echo >&2 "$0: unrecognized argument '$2'. Try: $0 --help"
68                 exit 1
69             fi
70             ;;
71     esac
72     shift
73 done
74
75 if [[ "$COMMAND" != "" ]]; then
76   COMMAND="/usr/local/rvm/bin/rvm-exec default bash /jenkins/$COMMAND --target $TARGET"
77 fi
78
79 STDOUT_IF_DEBUG=/dev/null
80 STDERR_IF_DEBUG=/dev/null
81 DASHQ_UNLESS_DEBUG=-q
82 if [[ "$DEBUG" != 0 ]]; then
83     STDOUT_IF_DEBUG=/dev/stdout
84     STDERR_IF_DEBUG=/dev/stderr
85     DASHQ_UNLESS_DEBUG=
86 fi
87
88 declare -a PYTHON_BACKPORTS PYTHON3_BACKPORTS
89
90 PYTHON2_VERSION=2.7
91 PYTHON3_VERSION=$(python3 -c 'import sys; print("{v.major}.{v.minor}".format(v=sys.version_info))')
92
93 ## These defaults are suitable for any Debian-based distribution.
94 # You can customize them as needed in distro sections below.
95 PYTHON2_PACKAGE=python$PYTHON2_VERSION
96 PYTHON2_PKG_PREFIX=python
97 PYTHON2_PREFIX=/usr
98 PYTHON2_INSTALL_LIB=lib/python$PYTHON2_VERSION/dist-packages
99
100 PYTHON3_PACKAGE=python$PYTHON3_VERSION
101 PYTHON3_PKG_PREFIX=python3
102 PYTHON3_PREFIX=/usr
103 PYTHON3_INSTALL_LIB=lib/python$PYTHON3_VERSION/dist-packages
104 ## End Debian Python defaults.
105
106 case "$TARGET" in
107     debian*)
108         FORMAT=deb
109         ;;
110     ubuntu*)
111         FORMAT=deb
112         ;;
113     centos*)
114         FORMAT=rpm
115         PYTHON2_PACKAGE=$(rpm -qf "$(which python$PYTHON2_VERSION)" --queryformat '%{NAME}\n')
116         PYTHON2_PKG_PREFIX=$PYTHON2_PACKAGE
117         PYTHON2_INSTALL_LIB=lib/python$PYTHON2_VERSION/site-packages
118         PYTHON3_PACKAGE=$(rpm -qf "$(which python$PYTHON3_VERSION)" --queryformat '%{NAME}\n')
119         PYTHON3_PKG_PREFIX=$PYTHON3_PACKAGE
120         PYTHON3_PREFIX=/opt/rh/python33/root/usr
121         PYTHON3_INSTALL_LIB=lib/python$PYTHON3_VERSION/site-packages
122         export PYCURL_SSL_LIBRARY=nss
123         ;;
124     *)
125         echo -e "$0: Unknown target '$TARGET'.\n" >&2
126         exit 1
127         ;;
128 esac
129
130
131 if ! [[ -n "$WORKSPACE" ]]; then
132   echo >&2 "$helpmessage"
133   echo >&2
134   echo >&2 "Error: WORKSPACE environment variable not set"
135   echo >&2
136   exit 1
137 fi
138
139 # Test for fpm
140 fpm --version >/dev/null 2>&1
141
142 if [[ "$?" != 0 ]]; then
143   echo >&2 "$helpmessage"
144   echo >&2
145   echo >&2 "Error: fpm not found"
146   echo >&2
147   exit 1
148 fi
149
150 PYTHON2_FPM_INSTALLER=(--python-easyinstall "$(find_python_program easy_install-$PYTHON2_VERSION easy_install)")
151 install3=$(find_python_program easy_install-$PYTHON3_VERSION easy_install3 pip-$PYTHON3_VERSION pip3)
152 if [[ $install3 =~ easy_ ]]; then
153     PYTHON3_FPM_INSTALLER=(--python-easyinstall "$install3")
154 else
155     PYTHON3_FPM_INSTALLER=(--python-pip "$install3")
156 fi
157
158 RUN_BUILD_PACKAGES_PATH="`dirname \"$0\"`"
159 RUN_BUILD_PACKAGES_PATH="`( cd \"$RUN_BUILD_PACKAGES_PATH\" && pwd )`"  # absolutized and normalized
160 if [ -z "$RUN_BUILD_PACKAGES_PATH" ] ; then
161   # error; for some reason, the path is not accessible
162   # to the script (e.g. permissions re-evaled after suid)
163   exit 1  # fail
164 fi
165
166 debug_echo "$0 is running from $RUN_BUILD_PACKAGES_PATH"
167 debug_echo "Workspace is $WORKSPACE"
168
169 if [[ -f /etc/profile.d/rvm.sh ]]; then
170     source /etc/profile.d/rvm.sh
171     GEM="rvm-exec default gem"
172 else
173     GEM=gem
174 fi
175
176 # Make all files world-readable -- jenkins runs with umask 027, and has checked
177 # out our git tree here
178 chmod o+r "$WORKSPACE" -R
179
180 # More cleanup - make sure all executables that we'll package are 755
181 cd "$WORKSPACE"
182 find -type d -name 'bin' |xargs -I {} find {} -type f |xargs -I {} chmod 755 {}
183
184 # Now fix our umask to something better suited to building and publishing
185 # gems and packages
186 umask 0022
187
188 debug_echo "umask is" `umask`
189
190 if [[ ! -d "$WORKSPACE/packages/$TARGET" ]]; then
191   mkdir -p $WORKSPACE/packages/$TARGET
192   chown --reference="$WORKSPACE" "$WORKSPACE/packages/$TARGET"
193 fi
194
195 # Perl packages
196 debug_echo -e "\nPerl packages\n"
197
198 if [[ -z "$ONLY_BUILD" ]] || [[ "libarvados-perl" = "$ONLY_BUILD" ]] ; then
199   cd "$WORKSPACE/sdk/perl"
200   libarvados_perl_version="$(version_from_git)"
201
202   cd $WORKSPACE/packages/$TARGET
203   test_package_presence libarvados-perl "$libarvados_perl_version"
204
205   if [[ "$?" == "0" ]]; then
206     cd "$WORKSPACE/sdk/perl"
207
208     if [[ -e Makefile ]]; then
209       make realclean >"$STDOUT_IF_DEBUG"
210     fi
211     find -maxdepth 1 \( -name 'MANIFEST*' -or -name "libarvados-perl*.$FORMAT" \) \
212         -delete
213     rm -rf install
214
215     perl Makefile.PL INSTALL_BASE=install >"$STDOUT_IF_DEBUG" && \
216         make install INSTALLDIRS=perl >"$STDOUT_IF_DEBUG" && \
217         fpm_build install/lib/=/usr/share libarvados-perl \
218         "Curoverse, Inc." dir "$(version_from_git)" install/man/=/usr/share/man \
219         "$WORKSPACE/apache-2.0.txt=/usr/share/doc/libarvados-perl/apache-2.0.txt" && \
220         mv --no-clobber libarvados-perl*.$FORMAT "$WORKSPACE/packages/$TARGET/"
221   fi
222 fi
223
224 # Ruby gems
225 debug_echo -e "\nRuby gems\n"
226
227 FPM_GEM_PREFIX=$($GEM environment gemdir)
228
229 cd "$WORKSPACE/sdk/ruby"
230 handle_ruby_gem arvados
231
232 cd "$WORKSPACE/sdk/cli"
233 handle_ruby_gem arvados-cli
234
235 cd "$WORKSPACE/services/login-sync"
236 handle_ruby_gem arvados-login-sync
237
238 # Python packages
239 debug_echo -e "\nPython packages\n"
240
241 cd "$WORKSPACE/sdk/pam"
242 handle_python_package
243
244 cd "$WORKSPACE/sdk/python"
245 handle_python_package
246
247 cd "$WORKSPACE/sdk/cwl"
248 handle_python_package
249
250 cd "$WORKSPACE/services/fuse"
251 handle_python_package
252
253 cd "$WORKSPACE/services/nodemanager"
254 handle_python_package
255
256 # arvados-src
257 (
258     cd "$WORKSPACE"
259     COMMIT_HASH=$(format_last_commit_here "%H")
260     arvados_src_version="$(version_from_git)"
261
262     cd $WORKSPACE/packages/$TARGET
263     test_package_presence arvados-src $arvados_src_version src ""
264
265     if [[ "$?" == "0" ]]; then
266       cd "$WORKSPACE"
267       SRC_BUILD_DIR=$(mktemp -d)
268       # mktemp creates the directory with 0700 permissions by default
269       chmod 755 $SRC_BUILD_DIR
270       git clone $DASHQ_UNLESS_DEBUG "$WORKSPACE/.git" "$SRC_BUILD_DIR"
271       cd "$SRC_BUILD_DIR"
272
273       # go into detached-head state
274       git checkout $DASHQ_UNLESS_DEBUG "$COMMIT_HASH"
275       echo "$COMMIT_HASH" >git-commit.version
276
277       cd "$SRC_BUILD_DIR"
278       PKG_VERSION=$(version_from_git)
279       cd $WORKSPACE/packages/$TARGET
280       fpm_build $SRC_BUILD_DIR/=/usr/local/arvados/src arvados-src 'Curoverse, Inc.' 'dir' "$PKG_VERSION" "--exclude=usr/local/arvados/src/.git" "--url=https://arvados.org" "--license=GNU Affero General Public License, version 3.0" "--description=The Arvados source code" "--architecture=all"
281
282       rm -rf "$SRC_BUILD_DIR"
283
284     fi
285 )
286
287 # Go binaries
288 cd $WORKSPACE/packages/$TARGET
289 export GOPATH=$(mktemp -d)
290 go get github.com/kardianos/govendor
291 package_go_binary cmd/arvados-client arvados-client \
292     "Arvados command line tool (beta)"
293 package_go_binary cmd/arvados-server arvados-server \
294     "Arvados server daemons"
295 package_go_binary cmd/arvados-server arvados-controller \
296     "Arvados cluster controller daemon"
297 package_go_binary sdk/go/crunchrunner crunchrunner \
298     "Crunchrunner executes a command inside a container and uploads the output"
299 package_go_binary services/arv-git-httpd arvados-git-httpd \
300     "Provide authenticated http access to Arvados-hosted git repositories"
301 package_go_binary services/crunch-dispatch-local crunch-dispatch-local \
302     "Dispatch Crunch containers on the local system"
303 package_go_binary services/crunch-dispatch-slurm crunch-dispatch-slurm \
304     "Dispatch Crunch containers to a SLURM cluster"
305 package_go_binary services/crunch-run crunch-run \
306     "Supervise a single Crunch container"
307 package_go_binary services/crunchstat crunchstat \
308     "Gather cpu/memory/network statistics of running Crunch jobs"
309 package_go_binary services/health arvados-health \
310     "Check health of all Arvados cluster services"
311 package_go_binary services/keep-balance keep-balance \
312     "Rebalance and garbage-collect data blocks stored in Arvados Keep"
313 package_go_binary services/keepproxy keepproxy \
314     "Make a Keep cluster accessible to clients that are not on the LAN"
315 package_go_binary services/keepstore keepstore \
316     "Keep storage daemon, accessible to clients on the LAN"
317 package_go_binary services/keep-web keep-web \
318     "Static web hosting service for user data stored in Arvados Keep"
319 package_go_binary services/ws arvados-ws \
320     "Arvados Websocket server"
321 package_go_binary tools/sync-groups arvados-sync-groups \
322     "Synchronize remote groups into Arvados from an external source"
323 package_go_binary tools/keep-block-check keep-block-check \
324     "Verify that all data from one set of Keep servers to another was copied"
325 package_go_binary tools/keep-rsync keep-rsync \
326     "Copy all data from one set of Keep servers to another"
327 package_go_binary tools/keep-exercise keep-exercise \
328     "Performance testing tool for Arvados Keep"
329
330
331 # we need explicit debian_revision values in the dependencies for ruamel.yaml, because we have a package iteration
332 # greater than zero. So we parse setup.py, get the ruamel.yaml dependencies, tell fpm not to automatically include
333 # them in the package being built, and re-add them manually with an appropriate debian_revision value.
334 # See #14552 for the reason for this (nasty) workaround. We use ${ruamel_depends[@]} in a few places further down
335 # in this script.
336 # Ward, 2018-11-28
337 IFS=', ' read -r -a deps <<< `grep ruamel.yaml $WORKSPACE/sdk/python/setup.py |cut -f 3 -dl |sed -e "s/'//g"`
338 declare -a ruamel_depends=()
339 for i in ${deps[@]}; do
340   i=`echo "$i" | sed -e 's!\([0-9]\)! \1!'`
341   if [[ $i =~ .*\>.* ]]; then
342     ruamel_depends+=(--depends "python-ruamel.yaml $i-1")
343   elif [[ $i =~ .*\<.* ]]; then
344     ruamel_depends+=(--depends "python-ruamel.yaml $i-9")
345   else
346     echo "Encountered ruamel dependency that I can't parse. Aborting..."
347     exit 1
348   fi
349 done
350
351
352 # The Python SDK
353 # Please resist the temptation to add --no-python-fix-name to the fpm call here
354 # (which would remove the python- prefix from the package name), because this
355 # package is a dependency of arvados-fuse, and fpm can not omit the python-
356 # prefix from only one of the dependencies of a package...  Maybe I could
357 # whip up a patch and send it upstream, but that will be for another day. Ward,
358 # 2014-05-15
359 cd $WORKSPACE/packages/$TARGET
360 rm -rf "$WORKSPACE/sdk/python/build"
361 arvados_python_client_version=${ARVADOS_BUILDING_VERSION:-$(awk '($1 == "Version:"){print $2}' $WORKSPACE/sdk/python/arvados_python_client.egg-info/PKG-INFO)}
362 test_package_presence ${PYTHON2_PKG_PREFIX}-arvados-python-client "$arvados_python_client_version" python
363 if [[ "$?" == "0" ]]; then
364
365   fpm_build $WORKSPACE/sdk/python "${PYTHON2_PKG_PREFIX}-arvados-python-client" 'Curoverse, Inc.' 'python' "$arvados_python_client_version" "--url=https://arvados.org" "--description=The Arvados Python SDK" --depends "${PYTHON2_PKG_PREFIX}-setuptools" --deb-recommends=git  --python-disable-dependency ruamel.yaml "${ruamel_depends[@]}"
366 fi
367
368 # cwl-runner
369 cd $WORKSPACE/packages/$TARGET
370 rm -rf "$WORKSPACE/sdk/cwl/build"
371 arvados_cwl_runner_version=${ARVADOS_BUILDING_VERSION:-$(awk '($1 == "Version:"){print $2}' $WORKSPACE/sdk/cwl/arvados_cwl_runner.egg-info/PKG-INFO)}
372 declare -a iterargs=()
373 if [[ -z "$ARVADOS_BUILDING_VERSION" ]]; then
374     arvados_cwl_runner_iteration=4
375     iterargs+=(--iteration $arvados_cwl_runner_iteration)
376 else
377     arvados_cwl_runner_iteration=
378 fi
379 test_package_presence ${PYTHON2_PKG_PREFIX}-arvados-cwl-runner "$arvados_cwl_runner_version" python "$arvados_cwl_runner_iteration"
380 if [[ "$?" == "0" ]]; then
381   fpm_build $WORKSPACE/sdk/cwl "${PYTHON2_PKG_PREFIX}-arvados-cwl-runner" 'Curoverse, Inc.' 'python' "$arvados_cwl_runner_version" "--url=https://arvados.org" "--description=The Arvados CWL runner" --depends "${PYTHON2_PKG_PREFIX}-setuptools" --depends "${PYTHON2_PKG_PREFIX}-subprocess32 >= 3.5.0" --depends "${PYTHON2_PKG_PREFIX}-pathlib2" --depends "${PYTHON2_PKG_PREFIX}-scandir" --python-disable-dependency ruamel.yaml "${ruamel_depends[@]}" "${iterargs[@]}"
382 fi
383
384 # schema_salad. This is a python dependency of arvados-cwl-runner,
385 # but we can't use the usual PYTHONPACKAGES way to build this package due to the
386 # intricacies of how version numbers get generated in setup.py: we need a specific version,
387 # e.g. 1.7.20160316203940. If we don't explicitly list that version with the -v
388 # argument to fpm, and instead specify it as schema_salad==1.7.20160316203940, we get
389 # a package with version 1.7. That's because our gittagger hack is not being
390 # picked up by self.distribution.get_version(), which is called from
391 # https://github.com/jordansissel/fpm/blob/master/lib/fpm/package/pyfpm/get_metadata.py
392 # by means of this command:
393 #
394 # python2.7 setup.py --command-packages=pyfpm get_metadata --output=metadata.json
395 #
396 # So we build this thing separately.
397 #
398 # Ward, 2016-03-17
399 saladversion=$(cat "$WORKSPACE/sdk/cwl/setup.py" | grep schema-salad== | sed "s/.*==\(.*\)'.*/\1/")
400 test_package_presence python-schema-salad "$saladversion" python 2
401 if [[ "$?" == "0" ]]; then
402   fpm_build schema_salad "" "" python $saladversion --depends "${PYTHON2_PKG_PREFIX}-lockfile >= 1:0.12.2-2" --depends "${PYTHON2_PKG_PREFIX}-avro = 1.8.1-2" --iteration 2
403 fi
404
405 # And for cwltool we have the same problem as for schema_salad. Ward, 2016-03-17
406 cwltoolversion=$(cat "$WORKSPACE/sdk/cwl/setup.py" | grep cwltool== | sed "s/.*==\(.*\)'.*/\1/")
407 test_package_presence python-cwltool "$cwltoolversion" python 3
408 if [[ "$?" == "0" ]]; then
409   fpm_build cwltool "" "" python $cwltoolversion --iteration 3 --python-disable-dependency ruamel.yaml "${ruamel_depends[@]}"
410 fi
411
412 # The PAM module
413 if [[ $TARGET =~ debian|ubuntu ]]; then
414     cd $WORKSPACE/packages/$TARGET
415     rm -rf "$WORKSPACE/sdk/pam/build"
416     libpam_arvados_version=$(awk '($1 == "Version:"){print $2}' $WORKSPACE/sdk/pam/arvados_pam.egg-info/PKG-INFO)
417     test_package_presence libpam-arvados "$libpam_arvados_version" python
418     if [[ "$?" == "0" ]]; then
419       fpm_build $WORKSPACE/sdk/pam libpam-arvados 'Curoverse, Inc.' 'python' "$libpam_arvados_version" "--url=https://arvados.org" "--description=PAM module for authenticating shell logins using Arvados API tokens" --depends libpam-python
420     fi
421 fi
422
423 # The FUSE driver
424 # Please see comment about --no-python-fix-name above; we stay consistent and do
425 # not omit the python- prefix first.
426 cd $WORKSPACE/packages/$TARGET
427 rm -rf "$WORKSPACE/services/fuse/build"
428 arvados_fuse_version=${ARVADOS_BUILDING_VERSION:-$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/fuse/arvados_fuse.egg-info/PKG-INFO)}
429 test_package_presence "${PYTHON2_PKG_PREFIX}-arvados-fuse" "$arvados_fuse_version" python
430 if [[ "$?" == "0" ]]; then
431   fpm_build $WORKSPACE/services/fuse "${PYTHON2_PKG_PREFIX}-arvados-fuse" 'Curoverse, Inc.' 'python' "$arvados_fuse_version" "--url=https://arvados.org" "--description=The Keep FUSE driver" --depends "${PYTHON2_PKG_PREFIX}-setuptools"
432 fi
433
434 # The node manager
435 cd $WORKSPACE/packages/$TARGET
436 rm -rf "$WORKSPACE/services/nodemanager/build"
437 nodemanager_version=${ARVADOS_BUILDING_VERSION:-$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/nodemanager/arvados_node_manager.egg-info/PKG-INFO)}
438 iteration="${ARVADOS_BUILDING_ITERATION:-1}"
439 test_package_presence arvados-node-manager "$nodemanager_version" python "$iteration"
440 if [[ "$?" == "0" ]]; then
441   fpm_build $WORKSPACE/services/nodemanager arvados-node-manager 'Curoverse, Inc.' 'python' "$nodemanager_version" "--url=https://arvados.org" "--description=The Arvados node manager" --depends "${PYTHON2_PKG_PREFIX}-setuptools" --iteration "$iteration"
442 fi
443
444 # The Docker image cleaner
445 cd $WORKSPACE/packages/$TARGET
446 rm -rf "$WORKSPACE/services/dockercleaner/build"
447 dockercleaner_version=${ARVADOS_BUILDING_VERSION:-$(awk '($1 == "Version:"){print $2}' $WORKSPACE/services/dockercleaner/arvados_docker_cleaner.egg-info/PKG-INFO)}
448 iteration="${ARVADOS_BUILDING_ITERATION:-4}"
449 test_package_presence arvados-docker-cleaner "$dockercleaner_version" python "$iteration"
450 if [[ "$?" == "0" ]]; then
451   fpm_build $WORKSPACE/services/dockercleaner arvados-docker-cleaner 'Curoverse, Inc.' 'python3' "$dockercleaner_version" "--url=https://arvados.org" "--description=The Arvados Docker image cleaner" --depends "${PYTHON3_PKG_PREFIX}-websocket-client = 0.37.0" --iteration "$iteration"
452 fi
453
454 # The Arvados crunchstat-summary tool
455 cd $WORKSPACE/packages/$TARGET
456 crunchstat_summary_version=${ARVADOS_BUILDING_VERSION:-$(awk '($1 == "Version:"){print $2}' $WORKSPACE/tools/crunchstat-summary/crunchstat_summary.egg-info/PKG-INFO)}
457 iteration="${ARVADOS_BUILDING_ITERATION:-2}"
458 test_package_presence "$PYTHON2_PKG_PREFIX"-crunchstat-summary "$crunchstat_summary_version" python "$iteration"
459 if [[ "$?" == "0" ]]; then
460   rm -rf "$WORKSPACE/tools/crunchstat-summary/build"
461   fpm_build $WORKSPACE/tools/crunchstat-summary ${PYTHON2_PKG_PREFIX}-crunchstat-summary 'Curoverse, Inc.' 'python' "$crunchstat_summary_version" "--url=https://arvados.org" "--description=Crunchstat-summary reads Arvados Crunch log files and summarize resource usage" --iteration "$iteration"
462 fi
463
464 # Forked libcloud
465 if test_package_presence "$PYTHON2_PKG_PREFIX"-apache-libcloud "$LIBCLOUD_PIN" python 2
466 then
467   LIBCLOUD_DIR=$(mktemp -d)
468   (
469       cd $LIBCLOUD_DIR
470       git clone $DASHQ_UNLESS_DEBUG https://github.com/curoverse/libcloud.git .
471       git checkout $DASHQ_UNLESS_DEBUG apache-libcloud-$LIBCLOUD_PIN
472       # libcloud is absurdly noisy without -q, so force -q here
473       OLD_DASHQ_UNLESS_DEBUG=$DASHQ_UNLESS_DEBUG
474       DASHQ_UNLESS_DEBUG=-q
475       handle_python_package
476       DASHQ_UNLESS_DEBUG=$OLD_DASHQ_UNLESS_DEBUG
477   )
478
479   # libcloud >= 2.3.0 now requires python-requests 2.4.3 or higher, otherwise
480   # it throws
481   #   ImportError: No module named packages.urllib3.poolmanager
482   # when loaded. We only see this problem on ubuntu1404, because that is our
483   # only supported distribution that ships with a python-requests older than
484   # 2.4.3.
485   fpm_build $LIBCLOUD_DIR "$PYTHON2_PKG_PREFIX"-apache-libcloud "" python "" --iteration 2 --depends 'python-requests >= 2.4.3'
486   rm -rf $LIBCLOUD_DIR
487 fi
488
489 # Python 2 dependencies
490 declare -a PIP_DOWNLOAD_SWITCHES=(--no-deps)
491 # Add --no-use-wheel if this pip knows it.
492 pip install --no-use-wheel >/dev/null 2>&1
493 case "$?" in
494     0) PIP_DOWNLOAD_SWITCHES+=(--no-use-wheel) ;;
495     1) ;;
496     2) ;;
497     *) echo "WARNING: 'pip install --no-use-wheel' test returned unknown exit code $?" ;;
498 esac
499
500 while read -r line || [[ -n "$line" ]]; do
501 #  echo "Text read from file: $line"
502   if [[ "$line" =~ ^# ]]; then
503     continue
504   fi
505   IFS='|'; arr=($line); unset IFS
506
507   dist=${arr[0]}
508
509   IFS=',';dists=($dist); unset IFS
510
511   MATCH=0
512   for d in "${dists[@]}"; do
513     if [[ "$d" == "$TARGET" ]] || [[ "$d" == "all" ]]; then
514       MATCH=1
515     fi
516   done
517
518   if [[ "$MATCH" != "1" ]]; then
519     continue
520   fi
521   name=${arr[1]}
522   version=${arr[2]}
523   iteration=${arr[3]}
524   pkgtype=${arr[4]}
525   arch=${arr[5]}
526   extra=${arr[6]}
527   declare -a 'extra_arr=('"$extra"')'
528
529   if [[ "$FORMAT" == "rpm" ]]; then
530     if [[ "$arch" == "all" ]]; then
531       arch="noarch"
532     fi
533     if [[ "$arch" == "amd64" ]]; then
534       arch="x86_64"
535     fi
536   fi
537
538   if [[ "$pkgtype" == "python" ]]; then
539     outname=$(echo "$name" | sed -e 's/^python-//' -e 's/_/-/g' -e "s/^/${PYTHON2_PKG_PREFIX}-/")
540   else
541     outname=$(echo "$name" | sed -e 's/^python-//' -e 's/_/-/g' -e "s/^/${PYTHON3_PKG_PREFIX}-/")
542   fi
543
544   if [[ -n "$ONLY_BUILD" ]] && [[ "$outname" != "$ONLY_BUILD" ]] ; then
545       continue
546   fi
547
548   case "$name" in
549       httplib2|google-api-python-client)
550           test_package_presence $outname $version $pkgtype $iteration $arch
551           if [[ "$?" == "0" ]]; then
552             # Work around 0640 permissions on some package files.
553             # See #7591 and #7991.
554             pyfpm_workdir=$(mktemp --tmpdir -d pyfpm-XXXXXX) && (
555                 set -e
556                 cd "$pyfpm_workdir"
557                 PIP_VERSION=`python$PYTHON2_VERSION -c "import pip; print(pip.__version__)" |cut -f1 -d.`
558                 if (( $PIP_VERSION < 8 )); then
559                   pip install "${PIP_DOWNLOAD_SWITCHES[@]}" --download . "$name==$version"
560                 else
561                   pip download --no-deps --no-binary :all: "$name==$version"
562                 fi
563                 # Sometimes pip gives us a tarball, sometimes a zip file...
564                 DOWNLOADED=`ls $name-*`
565                 [[ "$DOWNLOADED" =~ ".tar" ]] && tar -xf $DOWNLOADED
566                 [[ "$DOWNLOADED" =~ ".zip" ]] && unzip $DOWNLOADED
567                 cd "$name"-*/
568                 "python$PYTHON2_VERSION" setup.py $DASHQ_UNLESS_DEBUG egg_info build
569                 chmod -R go+rX .
570                 set +e
571                 fpm_build . "$outname" "" "$pkgtype" "$version" --iteration "$iteration" "${extra_arr[@]}"
572                 # The upload step uses the package timestamp to determine
573                 # if it is new.  --no-clobber plays nice with that.
574                 mv --no-clobber "$outname"*.$FORMAT "$WORKSPACE/packages/$TARGET"
575             )
576             if [ 0 != "$?" ]; then
577                 echo "ERROR: $name build process failed"
578                 EXITCODE=1
579             fi
580             if [ -n "$pyfpm_workdir" ]; then
581                 rm -rf "$pyfpm_workdir"
582             fi
583           fi
584           ;;
585       *)
586           test_package_presence $outname $version $pkgtype $iteration $arch
587           if [[ "$?" == "0" ]]; then
588             fpm_build "$name" "$outname" "" "$pkgtype" "$version" --iteration "$iteration" "${extra_arr[@]}"
589           fi
590           ;;
591   esac
592
593 done <`dirname "$(readlink -f "$0")"`"/build.list"
594
595 # Build the API server package
596 test_rails_package_presence arvados-api-server "$WORKSPACE/services/api"
597 if [[ "$?" == "0" ]]; then
598   handle_rails_package arvados-api-server "$WORKSPACE/services/api" \
599       "$WORKSPACE/agpl-3.0.txt" --url="https://arvados.org" \
600       --description="Arvados API server - Arvados is a free and open source platform for big data science." \
601       --license="GNU Affero General Public License, version 3.0"
602 fi
603
604 # Build the workbench server package
605 test_rails_package_presence arvados-workbench "$WORKSPACE/apps/workbench"
606 if [[ "$?" == "0" ]] ; then
607   (
608       set -e
609       cd "$WORKSPACE/apps/workbench"
610
611       # We need to bundle to be ready even when we build a package without vendor directory
612       # because asset compilation requires it.
613       bundle install --system >"$STDOUT_IF_DEBUG"
614
615       # clear the tmp directory; the asset generation step will recreate tmp/cache/assets,
616       # and we want that in the package, so it's easier to not exclude the tmp directory
617       # from the package - empty it instead.
618       rm -rf tmp
619       mkdir tmp
620
621       # Set up application.yml and production.rb so that asset precompilation works
622       \cp config/application.yml.example config/application.yml -f
623       \cp config/environments/production.rb.example config/environments/production.rb -f
624       sed -i 's/secret_token: ~/secret_token: xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx/' config/application.yml
625       sed -i 's/keep_web_url: false/keep_web_url: exampledotcom/' config/application.yml
626
627       RAILS_ENV=production RAILS_GROUPS=assets bundle exec rake npm:install >/dev/null
628       RAILS_ENV=production RAILS_GROUPS=assets bundle exec rake assets:precompile >/dev/null
629
630       # Remove generated configuration files so they don't go in the package.
631       rm config/application.yml config/environments/production.rb
632   )
633
634   if [[ "$?" != "0" ]]; then
635     echo "ERROR: Asset precompilation failed"
636     EXITCODE=1
637   else
638     handle_rails_package arvados-workbench "$WORKSPACE/apps/workbench" \
639         "$WORKSPACE/agpl-3.0.txt" --url="https://arvados.org" \
640         --description="Arvados Workbench - Arvados is a free and open source platform for big data science." \
641         --license="GNU Affero General Public License, version 3.0"
642   fi
643 fi
644
645 # clean up temporary GOPATH
646 rm -rf "$GOPATH"
647
648 exit $EXITCODE